/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo Wifi Smart Home V2.0 Lesson 2-3
 * 
 * tutorial url: https://osoyoo.com/?p=40187
 */
#define BLYNK_PRINT Serial

#include <BlynkSimpleShieldEsp8266.h>
#include <ESP8266_Lib.h>
char auth[] = "0ByWpc50cmOJ5O6OyHMaK4OSHkDvUeI-";//replace this with your Blynk Token
char server_ip[]="192.168.1.81"; // replace this line with your Blynk Server IP address

#define BLYNK_PRINT Serial
 
#include <dht.h>
 

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "***";//replace this line with your wifi ssid
char pass[] = "***"; //replace this line with your wifi password

#include <SoftwareSerial.h>
SoftwareSerial EspSerial(4, 5); // E_TX to D4, E_RX to D5
ESP8266 wifi(&EspSerial);
#define DHT11_PIN 2
dht DHT;
BlynkTimer timer;

// This function sends Arduino's up time every second to Virtual Pin (5).
// In the app, Widget's reading frequency should be set to PUSH. This means
// that you define how often to send data to Blynk App.
void sendSensor()
{
  int chk = DHT.read11(DHT11_PIN);
  float h = DHT.humidity;
  float t = DHT.temperature; // or dht.readTemperature(true) for Fahrenheit

  if (isnan(h) || isnan(t)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
 
 delay(500);
 
 delay(2000);
  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  Blynk.virtualWrite(V5, h);
  Blynk.virtualWrite(V6, t);
}

void setup()
{
  // Debug console
  Serial.begin(9600);
 
 
 delay(3000);
 while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("start");
  // set the data rate for the SoftwareSerial port
  EspSerial.begin(115200);
  EspSerial.write("AT+UART_DEF=9600,8,1,0,0\r\n");
  EspSerial.write("AT+RST\r\n");
  delay(100);
  EspSerial.begin(9600);

  //Blynk.begin(auth, wifi, ssid, pass);
 
  Blynk.begin(auth, wifi, ssid, pass,server_ip,8080);
  // Setup a function to be called every second
  timer.setInterval(1000L, sendSensor);
  
}

void loop()
{
  Blynk.run();
  timer.run();
}
